Attribute VB_Name = "Open"
Option Explicit

Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function IsIconic Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
 
Public Const SW_RESTORE = 9
Public Const WM_SETTEXT = &HC
Public Const BM_CLICK = &HF5 ' Top MS secret? Not included into API32.txt
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function EnumWindows& Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long)
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function EnumChildWindows& Lib "user32" (ByVal hParent As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long)
Dim bFound As Boolean
Dim hButton As Long
Dim sName As String
Public Sub ActivateWindow(h As Long)
 If h Then
    If IsIconic(h) Then
        Call ShowWindow(h, SW_RESTORE)
    End If
    Call SetForegroundWindow(h)
 Else
    Exit Sub 'no need to continue.
 End If
End Sub
Function EnumWinProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
  If bFound Then
     EnumWinProc = 0
     Exit Function
  Else
     Call EnumChildWindows(hwnd, AddressOf EnumChildWinProc, 0)
     EnumWinProc = 1
  End If
End Function

Function EnumChildWinProc(ByVal hwnd As Long, ByVal lParam As Long) As Long
  If GetWndText(hwnd) = sName Then
     EnumChildWinProc = 0
     bFound = True
     hButton = hwnd
     Exit Function
  Else
     EnumChildWinProc = 1
  End If
End Function

Private Function GetWndText(hwnd As Long) As String
  Dim k As Long, sName As String
  sName = Space$(128)
  k = GetWindowText(hwnd, sName, 128)
  If k > 0 Then sName = Left$(sName, k) Else sName = "No name"
  GetWndText = sName
End Function

Public Function GetButtonHandle(ByVal sCaption As String) As Long
  sName = sCaption
  Call EnumWindows(AddressOf EnumWinProc, 0)
  GetButtonHandle = hButton
End Function
